using System.Data;

namespace WinFormIsDirtyCS
{
  public class DirtyControls : System.Collections.Generic.List<DirtyControl>
  {
    private string mstrType = string.Empty;

    #region '"Load Method"'
    public void LoadControls(string FileName)
    {
      DataSet ds = new DataSet();
      DirtyControl dc = null;

      ds.ReadXml(FileName);
      foreach (System.Data.DataRow dr in ds.Tables[0].Rows)
      {
        dc = new DirtyControl();

        dc.Type = dr["Type"].ToString();
        dc.Property1 = dr["Property1"].ToString();
        dc.Property2 = dr["Property2"].ToString();
        dc.IsMultiList = ToBoolean(dr["IsMultiList"].ToString());
        dc.PropertyToCheck = dr["PropertyToCheck"].ToString();
        dc.PropertyToCheckValue = dr["PropertyToCheckValue"].ToString();

        this.Add(dc);
      }
    }

    private bool ToBoolean(string value)
    {
      bool boolRet = false;

      value = value.ToString().ToLower().Trim();

      if (value == "yes")
      {
        boolRet = true;
      }

      return boolRet;
    }
    #endregion

    #region '"Get Methods"'
    public virtual DirtyControl GetByType(string Type)
    {
      DirtyControl dc = null;

      mstrType = Type;
      dc = this.Find(FindByType);

      return dc;
    }

    private bool FindByType(DirtyControl dc)
    {
      if (dc.Type == mstrType)
      {
        return true;
      }
      else
      {
        return false;
      }
    }
    #endregion
  }
}