Public Class DirtyControls
  Inherits System.Collections.Generic.List(Of DirtyControl)

  Private mstrType As String = String.Empty

#Region "Load Method"
  Public Sub LoadControls(ByVal FileName As String)
    Dim ds As New DataSet
    Dim dc As DirtyControl

    ds.ReadXml(FileName)
    For Each dr As DataRow In ds.Tables(0).Rows
      dc = New DirtyControl

      dc.Type = dr("Type").ToString()
      dc.Property1 = dr("Property1").ToString()
      dc.Property2 = dr("Property2").ToString()
      dc.IsMultiList = ToBoolean(dr("IsMultiList").ToString())
      dc.PropertyToCheck = dr("PropertyToCheck").ToString()
      dc.PropertyToCheckValue = dr("PropertyToCheckValue").ToString()

      Me.Add(dc)
    Next
  End Sub

  Private Function ToBoolean(ByVal value As String) As Boolean
    Dim boolRet As Boolean = False

    value = value.ToString().ToLower().Trim()

    If value = "yes" Then
      boolRet = True
    End If

    Return boolRet
  End Function
#End Region

#Region "Get Methods"
  Public Overridable Function GetByType(ByVal Type As String) As DirtyControl
    Dim dc As DirtyControl = Nothing

    mstrType = Type
    dc = Me.Find(AddressOf FindByType)

    Return dc
  End Function

  Private Function FindByType(ByVal dc As DirtyControl) As Boolean
    If dc.Type = mstrType Then
      Return True
    Else
      Return False
    End If
  End Function
#End Region
End Class
